import rospy

from .resource_interface import *


class ResourceSet:
    def __init__(self, **kwargs):
        self.__resources = []
        {% for r in resources %}
        self.__{{ r.name }} = {{ r.name|data_name }}Resource(**kwargs)
        self.__resources.append(self.__{{ r.name }})
        {%- endfor %}

    {% for r in resources %}
    @property
    def {{ r.name }}(self):
        return self.__{{ r.name }}
    {% endfor %}

    def __iter__(self):
        return iter(self.__resources)

    def __len__(self):
        return len(self.__resources)

    def __nonzero__(self):
        return len(self.__resources) > 0

    def __getitem__(self, item):
        return getattr(self, item)

    def print_states(self):
        for r in self.__resources:
            r.print_state()